searchNodes=[{"doc":"Rewire is a libary for replacing hard-wired dependencies of the module your unit testing. This keeps your production code free from any unit testing-specific concerns.UsageGiven a module such as this:# this module has a hard-wired dependency on the `English` module defmodule Conversation do @punctuation &quot;!&quot; def start(), do: English.greet() &lt;&gt; @punctuation endIf you define a mox mock EnglishMock you can rewire the dependency in your unit test:defmodule MyTest do use ExUnit.Case, async: true import Rewire # (1) activate `rewire` import Mox rewire Conversation, English: EnglishMock # (2) rewire `English` to `EnglishMock` test &quot;start/0&quot; do stub(EnglishMock, :greet, fn -&gt; &quot;g&#39;day&quot; end) assert Conversation.start() == &quot;g&#39;day!&quot; # (3) test using the mock end endThis example uses mox, but rewire is mocking library-agnostic.You can use multiple rewires and multiple overrides: rewire Conversation, English: EnglishMock rewire OnlineConversation, Email: EmailMock, Chat: ChatMockYou can also give the alias a different name using as: rewire Conversation, English: EnglishMock, as: SmallTalkAlternatively, you can also rewire a module inside a block: rewire Conversation, English: EnglishMock do # (1) only rewired inside the block stub(EnglishMock, :greet, fn -&gt; &quot;g&#39;day&quot; end) assert Conversation.start() == &quot;g&#39;day!&quot; # (2) test using the mock endPlus, you can also rewire module attributes.","ref":"Rewire.html","title":"Rewire","type":"module"},{"doc":"Macro that allows to rewire (and alias) a module.import Rewire rewire App.ModuleToRewire, ModuleDep: Mock # `ModuleToRewire` will use `Mock` now endOptionsopts is a keyword list:as - give the rewired module a different nameany other item, like ModuleDep: Mock, will be interpreted as a mapping from one module to another","ref":"Rewire.html#rewire/2","title":"Rewire.rewire/2","type":"macro"},{"doc":"Abuse cover private functions to move stuff around.Adapted from mimic's solution: https://github.com/edgurgel/mimic/blob/5d3e651ce78473195c70ab86c9d2d0609a12dd3b/lib/mimic/cover.exWhich is based on meck's solution: https://github.com/eproxus/meck/blob/2c7ba603416e95401500d7e116c5a829cb558665/src/meck_cover.erl#L67-L91","ref":"Rewire.Cover.html","title":"Rewire.Cover","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"Rewire.Cover.html#child_spec/1","title":"Rewire.Cover.child_spec/1","type":"function"},{"doc":"","ref":"Rewire.Cover.html#compile/2","title":"Rewire.Cover.compile/2","type":"function"},{"doc":"","ref":"Rewire.Cover.html#enable_abstract_code/0","title":"Rewire.Cover.enable_abstract_code/0","type":"function"},{"doc":"","ref":"Rewire.Cover.html#start_link/1","title":"Rewire.Cover.start_link/1","type":"function"},{"doc":"","ref":"Rewire.Cover.html#track/2","title":"Rewire.Cover.track/2","type":"function"}]